        NAME    main
        PUBLIC  __iar_program_start
	SECTION .ZeroArea : CODE (4)
        CODE32
;----- Add Tester---------------
; 0x4014C598
__iar_program_start
	B	Port6000Manager
	B	StratupLoadLpugins
;----------------------------------------	
Port6000Manager
	ADD     R11, SP, #0x2C		;  
	LDRH	R3, [R11]		;  
	CMP	R3, #'?'		; 
	BNE	NoAsk
;  
        MOVS    R2, R4          	; len
        ADD     R1, SP, #0x118		; Buffer
	B	GoOut
;----------------------------	
NoAsk
	LDRH	R1, [R11, #0x02]	;   (half dword)
	LDR	R12,[R11, #0x04]	; Address
	LDR	R0, [R11, #0x08]	; First Parameter
	ADD     R11, SP, #0x48		;   
	CMP	R3, #'R'		; Read?
	BNE	NoRead
;--- Read Memory
	STR	R12, [R11], #4		; Save Read Address
	CMP	R1, #0x31		; Max buffer Size
	BLS	LenOk
	MOV	R1, #0x31
LenOk	
	STR	R1, [R11], #4		; SaveRead Size
CopyLoop	
	SUBS	R1, R1, #1		; Dec with flag set
	LDR	R0, [R12], #4		; Load Value from source
	STR	R0, [R11], #4		; Store To Target
	BPL	CopyLoop		; Iterate
	ADD     R1, SP, #0x48		;   
	SUB     R2, R11, R1	 	;  
	B	GoOut
;----------------------------	
NoRead
	CMP	R3, #'W'		; Write?
	BNE	NoWrite
;---- Write To memory
	STR	R0, [R12]		; Write To mem
	MVN	R0, R0			; Invert to test
	B	SendR0Back	
;------------------	
NoWrite
	CMP	R3, #'C'		; Call
	BNE	GoBack			; Unknown code - ignore
	BLX	R12			;  
SendR0Back	
	ADD     R11, SP, #0x2C		;  ,    
	STR	R0, [R11, #0x08]	; To Parameter1
SendBack
	MOV	R2, #0xC		;   
	MOV	R1, R11			;   
;---------    ----------------
GoOut
	;   
	LDR     R0, [SP,#0x3C]
        STR     R0, [SP,#0x10]
        LDRH    R0, [SP,#0x3A]
        STRH    R0, [SP,#0x0E]
;  	
        MOV     R0, #0x10       
        STR     R0, [SP,#0x4]		; to_len
        ADD     R0, SP, #0xC		;   
        STR     R0, [SP] 		; Toaddr
        MOV     R3, #0          	; flags
        MOVS    R0, R5          	; soc
	LDR	R12, =0x40273728	; lwip_sendto 
	BLX	R12			; Branch with Link
;     
GoBack
	LDR	R12, =0x403288D0	; Receive next packet address
	BX	R12
;--------------------------------------------------
StratupLoadLpugins
	
	
	BX	LR
        END
